(function () {
    "use strict";

    angular.module('core').controller('especieSerieDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'especieSerieService','$alert'];

    function controller($scope, $timeout, $state, $stateParams, especieSerieService, $alert) {
        $scope.initializeLayout('Espécie de Série');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            especieSerieService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.save = function () {
            $scope.state.carregando = true;
            especieSerieService
                .save($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.state.carregando = false;
                        $alert({ text: response.Message, title: $scope.Title });
                    } else {
                        $scope.historyBack();
                    }
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                });
        }




        /*Inicializa funções*/
        $scope.initialize();

    }

})();